
/**
 * @imports
 */
import Observer from '@web-native-js/observer';
import _copy from '@web-native-js/commons/obj/copy.js';
import ProximityObserver from '@web-native-js/firedom/ui/proximity/ProximityObserver.js';

/**
 * ---------------------------
 * Represents a ProximityObserver
 * that publishes entries to state.
 * ---------------------------
 */

export default class {
	
	/**
	 * @inheritdoc
	 */
	constructor(target, params = {}) {
		var observer = new ProximityObserver(entries => {
			entries.forEach(entry => {
				Observer.set(this, entry);
				if (params.once) {
					observer.unobserve(entry.target);
				}
			});
		}, _copy(params, ['root', 'rootMargin', 'axis']));
		observer.observe(target);
	}
};
